﻿using Model;
using Model.Stub;

namespace Console
{
    public class ConsoleProgram
    {
        public static IDataManager DataManager = new StubManager();

        public static Manager Manager = new(DataManager);

        public static Playlist p1 = Manager.Playlists.First();

        public static Title? current = p1.GetCurrentTitle();

        public static void Main()
        {
            Manager.AddPlaylist(new Playlist("MegaTeuf", "DescPlaylist", "ImagePlaylist"));

            System.Console.WriteLine(current?.Name);

            Next(2);

            p1.AddTitle(new CustomTitle("Nouveau", "img.png", "infos", "path.mp3"));
            p1.Shuffle = true;

            Separator();

            Next(5);

            Separator();

            Previous(5);

            Separator();

            Next(2);

            Separator();

            Previous(10);

            Manager.LoadSerialization();

            DisplaySerialization(Manager.GetPlaylists());
            DisplaySerialization(Manager.GetAlbums());
            DisplaySerialization(Manager.GetArtists());
            DisplaySerialization(Manager.GetCustomTitles());
            DisplaySerialization(Manager.GetInfoTitles());

            Artist newArtist = new();
            Manager.AddArtist(newArtist);
            Manager.AddAlbum(new Album("Nouvel album", "nouveau.png", newArtist, "nouvelle desc", "nouvelles infos"));

            Separator();

            DisplaySerialization(Manager.GetAlbums());

            Manager.SaveSerialization();
        }

        public static void Next(int n)
        {
            for (int i = 0; i < n; i++)
            {
                p1.NextTitle();
                current = p1.GetCurrentTitle();
                System.Console.WriteLine(current?.Name);
            }
        }

        public static void Previous(int n)
        {
            for (int i = 0; i < n; i++)
            {
                p1.PreviousTitle();
                current = p1.GetCurrentTitle();
                System.Console.WriteLine(current?.Name);
            }
        }

        public static void DisplaySerialization<T>(IEnumerable<T> objects)
        {
            foreach (var obj in objects)
            {
                System.Console.WriteLine(obj);
            }
        }

        public static void Separator()
        {
            System.Console.WriteLine("--------------------");
        }
    }
}